
var snippetDetails = window.textexpander.snippetDetails;

var editSessionListener = snippetDetails.editSession.editSessionListener;
editSessionListener.editingStarted = (snippetId) => {
    window.webkit.messageHandlers.editingStarted.postMessage(snippetId);

};
editSessionListener.edited = (snippetId, beforeEdit, afterEdit) => {
    window.webkit.messageHandlers.editedSnippet.postMessage({
        snippetId: snippetId,
        snippetJSON: JSON.stringify(afterEdit)
    });
};

editSessionListener.editingFinished = (snippetId) => {
    window.webkit.messageHandlers.editingFinished.postMessage(snippetId);
};

editSessionListener.editingIdle = (snippetId) => {
    window.webkit.messageHandlers.editingFinished.postMessage(snippetId);
};

editSessionListener.useTimeout = true;

// Function to tell host app to fetch snippet content for preview.
snippetDetails.snippetContentFetchFn = function(embedSnippetParam) {
	// Store the embedSnippetParam in the delegate so completion callback can access it.
	snippetDetails.curEmbedSnippetParam = embedSnippetParam;
	try {
		window.webkit.messageHandlers.fetchSnippet.postMessage(embedSnippetParam.abbreviation);
	} catch (error) {
		embedSnippetParam.failed(error);
		snippetDetails.curEmbedSnippetParam = null;
	}
};

// Snippet content fetch completion function called by the host app.
// whichCompletion should be either 'completed', 'notFound' or 'failed'.
// For 'failed' case, put any error description into snippetContent.
snippetDetails.snippetFetchCompletion = function(rawSnippetType, snippetContent, whichCompletion, matchedAbbreviation) {
	snippetDetails.curEmbedSnippetParam.snippetType = rawSnippetType;
	snippetDetails.curEmbedSnippetParam.snippetContent = snippetContent;
	if (matchedAbbreviation) {
		snippetDetails.curEmbedSnippetParam.matchedAbbreviation = matchedAbbreviation;
	}
	snippetDetails.curEmbedSnippetParam[whichCompletion](whichCompletion == 'failed' ? snippetContent : null);
	snippetDetails.curEmbedSnippetParam = null;
}

